// Written by TeTeT



/**
[maas, plane] spawn {
	params ["_maas", "_plane"];
	private ["_thPos", "_pointPlane", "_wire",
		     "_dWide", "_dLong", "_dHigh"];

	_wire = _maas selectionPosition "wire2";

	_plane animate ["tailhook", 1, true];
	_plane setVelocity [0,0,-0.5];
	sleep 1;
	_thPos = _plane modelToWorld (_plane selectionPosition "tailhook");
	_tailhookAnim = _plane animationPhase "tailhook";
	_pointPlane = _maas worldToModel _thPos;

	_dWide = (_pointPlane select 0) - (_wire select 0);
	_dLong = (_pointPlane select 1) - (_wire select 1);
	_dHigh = (_pointPlane select 2) - (_wire select 2);

	_maas animate ["ani_cable2_wide", _dWide];
	_maas animate ["ani_cable2_long", _dLong];
	_maas animate ["ani_cable2_high", _dHigh];
};
**/

plane animate ["tailhook", 1, true];

ttt_maas_fnc_wires = {

	params ["_plane"];

	private ["_p1", "_p2", "_p3", "_p4", "_thPos", "_pointPlane",
			"_d1", "_d2", "_d3", "_d4", "_cableA", "_cableB", "_cable"];

	_p1 = maas selectionPosition "wire1";
	_p2 = maas selectionPosition "wire2";
	_p3 = maas selectionPosition "wire3";
	_p4 = maas selectionPosition "wire4";

	_thPos = _plane modelToWorld (_plane selectionPosition "tailhook");
	_pointPlane = maas worldToModel _thPos;

	_d1 = _pointPlane distance _p1;
	_d2 = _pointPlane distance _p2;
	_d3 = _pointPlane distance _p3;
	_d4 = _pointPlane distance _p4;

	_cableA = _d1 min _d2;
	_cableB = _d3 min _d4;
	_cable = _cableA min _cableB;
	_anims = [];
	switch (_cable) do {
		case _d1: {
		while{true} do{
			_pointJet = maas worldToModel (_plane modelToWorld (_plane selectionPosition "tailhook"));
			_dWide = (_pointJet select 0) - (_p1 select 0);
			_dLong = (_pointJet select 1) - (_p1 select 1);
			_dHigh = ((_pointJet select 2) - (_p1 select 2));

			maas animate["ani_cable1_wide", _dWide];
			maas animate["ani_cable1_long", _dLong];
			maas animate["ani_cable1_high", _dHigh];
			sleep 0.04;

			if (_plane animationPhase "tailhook" < 1) exitWith {
			  maas animate["ani_cable1_wide", 0];
			  maas animate["ani_cable1_long", 0];
			  maas animate["ani_cable1_high", 0];
			};
		};
		};
		case _d2: {
		while{true} do{
			_pointJet = maas worldToModel (_plane modelToWorld (_plane selectionPosition "tailhook"));
			_dWide = (_pointJet select 0) - (_p2 select 0);
			_dLong = (_pointJet select 1) - (_p2 select 1);
			_dHigh = ((_pointJet select 2) - (_p2 select 2));

			maas animate["ani_cable2_wide", _dWide];
			maas animate["ani_cable2_long", _dLong];
			maas animate["ani_cable2_high", _dHigh];
			sleep 0.04;

			if (_plane animationPhase "tailhook" < 1) exitWith {
			  maas animate["ani_cable2_wide", 0];
			  maas animate["ani_cable2_long", 0];
			  maas animate["ani_cable2_high", 0];
			};
		};

		};
		case _d3: {
		while{true} do{
			_pointJet = maas worldToModel (_plane modelToWorld (_plane selectionPosition "tailhook"));
			_dWide = (_pointJet select 0) - (_p3 select 0);
			_dLong = (_pointJet select 1) - (_p3 select 1);
			_dHigh = ((_pointJet select 2) - (_p3 select 2));

			maas animate["ani_cable3_wide", _dWide];
			maas animate["ani_cable3_long", _dLong];
			maas animate["ani_cable3_high", _dHigh];
			sleep 0.04;

			if (_plane animationPhase "tailhook" < 1) exitWith {
			  maas animate["ani_cable3_wide", 0];
			  maas animate["ani_cable3_long", 0];
			  maas animate["ani_cable3_high", 0];
			};
		};

		};
		case _d4: {
		while{true} do{
			_pointJet = maas worldToModel (_plane modelToWorld (_plane selectionPosition "tailhook"));
			_dWide = (_pointJet select 0) - (_p4 select 0);
			_dLong = (_pointJet select 1) - (_p4 select 1);
			_dHigh = ((_pointJet select 2) - (_p4 select 2));

			maas animate["ani_cable4_wide", _dWide];
			maas animate["ani_cable4_long", _dLong];
			maas animate["ani_cable4_high", _dHigh];
			sleep 0.04;

			if (_plane animationPhase "tailhook" < 1) exitWith {
			  maas animate["ani_cable4_wide", 0];
			  maas animate["ani_cable4_long", 0];
			  maas animate["ani_cable4_high", 0];
			};
		};

		};
	};
};

ttt_maas_fnc_useWires = {
	params ["_vehicleList"];

	{
		if (_x isKindOf "Plane") then {
			systemChat "Plane approaching";

			if (getPosATL _x select 2 < 50 and _x animationPhase "tailhook" == 1) then {
				systemChat "plane possibly landing";

				waitUntil { ((getPosATL _x select 2) - (getPosATL maas select 2)) < 0.2; };
				waitUntil { (_x distance maas) < 10; };

				if ( (_x distance maas) < 10 and (speed _x) < 250 ) then {
					systemChat "Touchdown, braking";
					[_x] spawn ttt_maas_fnc_wires;
					sleep 0.5;
					while {alive _x and speed _x > 0.1} do {
					 	private ["_vel"];
					 	_vel = velocity _x;
					 	_x setVelocity [(_vel select 0) * 0.7,
					 				    (_vel select 1) * 0.7,
					 				    (_vel select 2) * 0.7];
					    sleep 0.2;
					};

					waitUntil {_x setVelocity [0,0,-0.5]; _x animationPhase "tailhook" < 1};

				} else {
					systemChat "Abort";
				};
			};
		};
	} forEach _vehicleList;
};

private ["_trigger"];

_trigger = createTrigger ["EmptyDetector", getPos maas];
_trigger setTriggerArea [100,100,100,false];
_trigger setTriggerActivation ["WEST", "PRESENT", false];
_trigger setTriggerStatements ["this", "[thisList] spawn ttt_maas_fnc_useWires;", "hint 'trigger off'"];

